' GetExcelObjects.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-04-10
' GetExcelObjects.VBS gets running Excel objects.
' Usage: Start GetExcelObjects.VBS

Option Explicit
Dim wShell
Dim fso
Dim dic
Dim xl
Dim Book
Dim Rows
Dim Path
Dim Folder
Dim File
Dim Link

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")
Set dic=CreateObject("Scripting.Dictionary")

Sub GetFirstExcel()
On Error Resume Next
Set xl=GetObject(,"Excel.Application")
End Sub

Call GetFirstExcel()
If Err.Number=0 Then
  dic.Add xl,1
'  MsgBox xl.StartupPath
  Set Folder=fso.GetFolder(xl.StartupPath&"\..\..\Office\Recent")
  For Each File In Folder.Files
    If LCase(fso.GetExtensionName(File.Name))<>"lnk" Then
    ElseIf LCase(fso.GetBaseName(fso.GetBaseName(File.Name)))="personal" Then
    ElseIf LCase(fso.GetExtensionName(fso.GetBaseName(File.Name)))="xls" Then
      Set Link=wShell.CreateShortCut(File.Path)
      Path=Link.TargetPath
      If fso.FileExists(Path) Then
        Call IsOpen(Path)
        If Err Then
          Set Book=GetObject(Path)
          Set xl=Book.Application
          If Not dic.Exists(xl) Then
            dic.Add xl,0
          End If
        End If
      End If
    End If
  Next
End If

Rows=Array()
Push Rows,Join(Array("Number Of Excel Objects",dic.Count),vbTab)
For Each xl In dic
  Push Rows,Join(Array("WorkBooks.Count",xl.WorkBooks.Count),vbTab)
  For Each Book In xl.WorkBooks
      Push Rows,Join(Array("Book.Name",Book.Name),vbTab)
  Next
Next
WScript.Echo Join(Rows,vbLf)

Function IsOpen(Path)
On Error Resume Next
Call fso.OpenTextFile(Path,8)
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
