' GetExcelObjects.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-04-10
' GetExcelObjects.VBS gets running Excel objects.
' Usage: Start GetExcelObjects.VBS

Option Explicit
Dim wShell
Dim fso
Dim dic
Dim xl
Dim Book
Dim Rows
Dim Path
Dim Line
Dim tPath
Dim StdOut
Dim fTool

Const openfiles="C:\Windows\System32\openfiles.exe"
Const handle="C:\Program Files\Handle\handle.exe"
Const oh="C:\Program Files\Resource Kit\oh.exe"

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")
Set dic=CreateObject("Scripting.Dictionary")

Sub GetFirstExcel()
On Error Resume Next
Set xl=GetObject(,"Excel.Application")
End Sub

Call GetFirstExcel()
If Err.Number=0 Then
  dic.Add xl,1

  tPath=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetTempName())
  If fso.FileExists(openfiles) Then
    Call wShell.Run("CMD.EXE /S /C "" """& openfiles &""" >"""& tPath &""" """,0,True)
    fTool=1
  ElseIf fso.FileExists(handle) Then
    Call wShell.Run("CMD.EXE /S /C "" """& handle &""" .xls >"""& tPath &""" """,0,True)
    fTool=2
  ElseIf fso.FileExists(oh) Then
    Call wShell.Run(""""& oh &""" -t file -o """& tPath &""" .xls",0,True)
    fTool=3
  Else
    WScript.Echo "Neither OPENFILES.EXE, HANDLE.EXE nor OH.EXE exists."
    WScript.Quit
  End If

  Set StdOut=fso.OpenTextFile(tPath)
  Do While Not StdOut.AtEndOfStream
    Line=StdOut.ReadLine
    Select Case fTool
    Case 1 Path=Mid(Line,28)
    Case 2 Path=Mid(Line,38)
    Case 3 Path="C:"& Mid(Line,45)
    End Select
    If LCase(fso.GetExtensionName(Path))<>"xls" Then
    ElseIf fso.FileExists(Path) Then
      Set Book=GetObject(Path)
      Set xl=Book.Application
      If Not dic.Exists(xl) Then
        dic.Add xl,0
      End If
    End If
  Loop
  StdOut.Close
  fso.DeleteFile tPath
End If

Rows=Array()
Push Rows,Join(Array("Number Of Excel Objects",dic.Count),vbTab)
For Each xl In dic
  Push Rows,Join(Array("WorkBooks.Count",xl.WorkBooks.Count),vbTab)
  For Each Book In xl.WorkBooks
      Push Rows,Join(Array("Book.Name",Book.Name),vbTab)
  Next
Next
WScript.Echo Join(Rows,vbLf)

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
